/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package JDiskCat;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.util.prefs.Preferences;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.GroupLayout.Alignment;
import javax.swing.DefaultListModel;
import javax.swing.GroupLayout;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.JToolBar;
import javax.swing.JScrollPane;
import javax.swing.JList;
import javax.swing.JButton;
import javax.swing.ImageIcon;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
/**
 *
 * @author sebe
 */
public class SettingsWindow extends javax.swing.JFrame {

    /**
     * 
     */
    private static final long serialVersionUID = -3138649039118237115L;
    /**
     * Creates new form SettingsWindow
     */
    public SettingsWindow() {
        initComponents();
        //jCheckBox2.setVisible(false);
        // get window size
        Dimension dialogSize = getSize();
        // get desktop size
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        if (dialogSize.height > screenSize.height) {
            dialogSize.height = screenSize.height;
        }
        if (dialogSize.width > screenSize.width) {
            dialogSize.height = screenSize.width;
        }

        // place window in the middle of the screen
        setLocation((screenSize.width - dialogSize.width) / 2,
                (screenSize.height - dialogSize.height) / 2);
        
        Preferences prefs = Preferences.userNodeForPackage(this.getClass());
        //prefs.put("LAST_OUTPUT_DIR", mostRecentOutputDirectory.getAbsolutePath());
        boolean nerdMode = prefs.getBoolean("NERD_MODE", false);
        jCheckBox1.setSelected(nerdMode);
        boolean grayFolderRows = prefs.getBoolean("GRAY_FOLDER_ROWS", false);
        jCheckBox2.setSelected(grayFolderRows);
        boolean skipAliases = prefs.getBoolean("SKIP_ALIASES", true);
        chckbxSkipCataloguingSymlinksaliases.setSelected(skipAliases);
        boolean sortIgnoreCase = prefs.getBoolean("SORT_IGNORE_CASE", true);
        chckbxCaseInsensitiveFile.setSelected(sortIgnoreCase);
        boolean systemLook = prefs.getBoolean("SYSTEM_LOOK", true);
        chckbxUseSystemLook.setSelected(systemLook);
        boolean writeZipFiles = prefs.getBoolean("WRITE_ZIPPED_FILES", true);
        chckbxWriteZippedCatalog.setSelected(writeZipFiles);
        boolean excludeHidden = prefs.getBoolean("EXCLUDE_HIDDEN", false);
        chckbxExcludeHiddenFiles.setSelected(excludeHidden);
        
        String exclusions = prefs.get("EXCLUSIONS", "");
        if(!exclusions.isEmpty()) {
            String[] names=exclusions.split("<dir>");
            for(int i=0;i<names.length;i++) {
                listModel.addElement(names[i]);
            }
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    //@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jCheckBox1 = new javax.swing.JCheckBox();
        jCheckBox2 = new javax.swing.JCheckBox();
        jButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("JDiskCat settings");

        jTabbedPane1.setTabPlacement(javax.swing.JTabbedPane.LEFT);
        jTabbedPane1.setName(""); // NOI18N

        jCheckBox1.setText("Nerd mode (always display size in bytes)");
        jCheckBox1.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox1ItemStateChanged(evt);
            }
        });

        jCheckBox2.setText("Display directory rows with a different background color (restart required)");
        jCheckBox2.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox2ItemStateChanged(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jCheckBox2)
                    .addComponent(jCheckBox1))
                .addContainerGap(50, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jCheckBox2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jCheckBox1)
                .addContainerGap(286, Short.MAX_VALUE))
        );
        
        chckbxSkipCataloguingSymlinksaliases = new JCheckBox();
        chckbxSkipCataloguingSymlinksaliases.setToolTipText("Symlinks can cause endless loops if they point to the parent directory of the symlink's location. Also reduces catalog size and cataloguing duration.");
        chckbxSkipCataloguingSymlinksaliases.addItemListener(new java.awt.event.ItemListener() {
                public void itemStateChanged(java.awt.event.ItemEvent evt) {
                    chckbxSkipCataloguingSymlinksaliasesItemStateChanged(evt);
                }
        });
        chckbxSkipCataloguingSymlinksaliases.setText("Skip cataloguing symlinks/aliases");
        
        chckbxCaseInsensitiveFile = new JCheckBox("Case-insensitive file sorting (non-Windows OS only)");
        chckbxCaseInsensitiveFile.setToolTipText("Normal sorting puts all files and folders starting with capital letters first (A.. to Z before a.. to z..)");
        chckbxCaseInsensitiveFile.addItemListener(new ItemListener() {
                public void itemStateChanged(ItemEvent arg0) {
                    Preferences prefs = Preferences.userNodeForPackage(this.getClass());
                    prefs.putBoolean("SORT_IGNORE_CASE", chckbxCaseInsensitiveFile.isSelected());
                }
        });
        
        chckbxUseSystemLook = new JCheckBox("Use system look and feel");
        chckbxUseSystemLook.addItemListener(new ItemListener() {
                public void itemStateChanged(ItemEvent e) {
                    Preferences prefs = Preferences.userNodeForPackage(this.getClass());
                    prefs.putBoolean("SYSTEM_LOOK", chckbxUseSystemLook.isSelected());
                }
        });
        
        chckbxWriteZippedCatalog = new JCheckBox("Write zipped catalog files");
        chckbxWriteZippedCatalog.setToolTipText("Write compressed catalog files (incompatible with earlier versions of JDiskCat without manual unzipping)");
        chckbxWriteZippedCatalog.addItemListener(new ItemListener() {
                public void itemStateChanged(ItemEvent e) {
                    Preferences prefs = Preferences.userNodeForPackage(this.getClass());
                    prefs.putBoolean("WRITE_ZIPPED_FILES", chckbxWriteZippedCatalog.isSelected());
                }
        });
        chckbxWriteZippedCatalog.setSelected(true);
        
        chckbxExcludeHiddenFiles = new JCheckBox("Skip hidden files and folders");
        chckbxExcludeHiddenFiles.setToolTipText("Exclude all hidden files and folders.");
        chckbxExcludeHiddenFiles.addChangeListener(new ChangeListener() {
                public void stateChanged(ChangeEvent arg0) {
                    Preferences prefs = Preferences.userNodeForPackage(this.getClass());
                    prefs.putBoolean("EXCLUDE_HIDDEN", chckbxExcludeHiddenFiles.isSelected());
                }
        });
        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2Layout.setHorizontalGroup(
                jPanel2Layout.createParallelGroup(Alignment.LEADING)
                        .addGroup(jPanel2Layout.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(jPanel2Layout.createParallelGroup(Alignment.LEADING)
                                        .addComponent(chckbxSkipCataloguingSymlinksaliases, GroupLayout.PREFERRED_SIZE, 261, GroupLayout.PREFERRED_SIZE)
                                        .addComponent(chckbxCaseInsensitiveFile)
                                        .addComponent(chckbxUseSystemLook)
                                        .addComponent(chckbxWriteZippedCatalog)
                                        .addComponent(chckbxExcludeHiddenFiles))
                                .addContainerGap(240, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
                jPanel2Layout.createParallelGroup(Alignment.LEADING)
                        .addGroup(jPanel2Layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(chckbxSkipCataloguingSymlinksaliases)
                                .addPreferredGap(ComponentPlacement.UNRELATED)
                                .addComponent(chckbxCaseInsensitiveFile)
                                .addPreferredGap(ComponentPlacement.UNRELATED)
                                .addComponent(chckbxUseSystemLook)
                                .addPreferredGap(ComponentPlacement.UNRELATED)
                                .addComponent(chckbxWriteZippedCatalog)
                                .addPreferredGap(ComponentPlacement.UNRELATED)
                                .addComponent(chckbxExcludeHiddenFiles)
                                .addContainerGap(203, Short.MAX_VALUE))
        );
        jPanel2.setLayout(jPanel2Layout);

        jTabbedPane1.addTab("Display", jPanel1);
        jTabbedPane1.addTab("Cataloguing ", jPanel2);
        jTabbedPane1.addTab("Exclusions ", jPanel3);
        
        JToolBar toolBar = new JToolBar();
        
        JScrollPane scrollPane = new JScrollPane();
        GroupLayout gl_jPanel3 = new GroupLayout(jPanel3);
        gl_jPanel3.setHorizontalGroup(
                gl_jPanel3.createParallelGroup(Alignment.LEADING)
                        .addGroup(Alignment.TRAILING, gl_jPanel3.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(gl_jPanel3.createParallelGroup(Alignment.TRAILING)
                                        .addComponent(scrollPane, Alignment.LEADING, GroupLayout.DEFAULT_SIZE, 549, Short.MAX_VALUE)
                                        .addComponent(toolBar, Alignment.LEADING, GroupLayout.DEFAULT_SIZE, 549, Short.MAX_VALUE))
                                .addContainerGap())
        );
        gl_jPanel3.setVerticalGroup(
                gl_jPanel3.createParallelGroup(Alignment.LEADING)
                        .addGroup(gl_jPanel3.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(toolBar, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(ComponentPlacement.RELATED)
                                .addComponent(scrollPane, GroupLayout.DEFAULT_SIZE, 299, Short.MAX_VALUE)
                                .addContainerGap())
        );
        
        btnAdd = new JButton("Add");
        btnAdd.addMouseListener(new MouseAdapter() {
                @Override
                public void mouseReleased(MouseEvent evt) {
                    btnAddMouseReleased(evt);
                }
        });
        btnAdd.setIcon(new ImageIcon(SettingsWindow.class.getResource("/JDiskCat/img/list-add.png")));
        toolBar.add(btnAdd);
        
        btnRemove = new JButton("Remove");
        btnRemove.addMouseListener(new MouseAdapter() {
                @Override
                public void mouseReleased(MouseEvent e) {
                    if(list.getSelectedIndex()!=-1) {
                        listModel.removeElementAt(list.getSelectedIndex());
                        updateExcusionsPrefs();
                    }                    
                }
        });
        btnRemove.setIcon(new ImageIcon(SettingsWindow.class.getResource("/JDiskCat/img/list-remove.png")));
        toolBar.add(btnRemove);
        
        btnClear = new JButton("Clear");
        btnClear.addMouseListener(new MouseAdapter() {
                @Override
                public void mouseReleased(MouseEvent e) {
                    listModel.clear();
                    updateExcusionsPrefs();
                }
        });
        btnClear.setIcon(new ImageIcon(SettingsWindow.class.getResource("/JDiskCat/img/edit-clear.png")));
        toolBar.add(btnClear);
        
        list = new JList<String>();
        scrollPane.setViewportView(list);
        jPanel3.setLayout(gl_jPanel3);
        listModel = new DefaultListModel<String>();
        list.setModel(listModel);
        list.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        list.setDoubleBuffered(true);

        jButton1.setText("OK");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jButton1MouseReleased(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(jButton1))
                    .addComponent(jTabbedPane1))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton1MouseReleased
        this.setVisible(false);
    }//GEN-LAST:event_jButton1MouseReleased

    private void jCheckBox1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox1ItemStateChanged
        Preferences prefs = Preferences.userNodeForPackage(this.getClass());
        prefs.putBoolean("NERD_MODE", jCheckBox1.isSelected());
    }//GEN-LAST:event_jCheckBox1ItemStateChanged

    private void jCheckBox2ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox2ItemStateChanged
        Preferences prefs = Preferences.userNodeForPackage(this.getClass());
        prefs.putBoolean("GRAY_FOLDER_ROWS", jCheckBox2.isSelected());
    }//GEN-LAST:event_jCheckBox2ItemStateChanged
    
    private void chckbxSkipCataloguingSymlinksaliasesItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox2ItemStateChanged
        Preferences prefs = Preferences.userNodeForPackage(this.getClass());
        prefs.putBoolean("SKIP_ALIASES", chckbxSkipCataloguingSymlinksaliases.isSelected());
    }//GEN-LAST:event_jCheckBox2ItemStateChanged
    
    private void btnAddMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnAddMouseReleased
        //Add selected directories to the exclusion list
        JFileChooser chooser;
        chooser = new JFileChooser();
        chooser.setCurrentDirectory(new java.io.File("."));
        chooser.setDialogTitle("Select one or more file or directory to be excluded from cataloguing");
        chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES/*.DIRECTORIES_ONLY*/);
        //chooser.setAcceptAllFileFilterUsed(false);//Don't accept all file types
        chooser.setMultiSelectionEnabled(true);
        chooser.setFileHidingEnabled(false);

        if (chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            File[] files = chooser.getSelectedFiles();
            for(int i=0;i<files.length;i++) {
                listModel.addElement(files[i].getName());
            }
            updateExcusionsPrefs();
        }/* else {
            System.out.println("Nothing selected!");
        }*/
    }//GEN-LAST:event_jButton1MouseReleased
    
    public void updateExcusionsPrefs() {
        String names="";
        for(int i=0;i<listModel.getSize();i++) {
            if(i==0)
                names+=listModel.getElementAt(i);
            else
                names+="<dir>"+listModel.getElementAt(i);
        }
        Preferences prefs = Preferences.userNodeForPackage(this.getClass());
        prefs.put("EXCLUSIONS", names);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        /*
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(SettingsWindow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(SettingsWindow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(SettingsWindow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(SettingsWindow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }*/
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new SettingsWindow().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JPanel jPanel1, jPanel2, jPanel3;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JCheckBox chckbxSkipCataloguingSymlinksaliases;
    private JCheckBox chckbxCaseInsensitiveFile;
    private JCheckBox chckbxUseSystemLook;
    private JButton btnAdd;
    private JButton btnRemove;
    private JButton btnClear;
    private JList<String> list;
    private static DefaultListModel<String> listModel;
    private JCheckBox chckbxWriteZippedCatalog;
    private JCheckBox chckbxExcludeHiddenFiles;
}
